using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;
namespace AnimatedWindow
{
	
	public class WinAPIClass
	{
		#region  
		/// <summary>
		///   .     int
		///  .     
		///    int.
		/// </summary>	
		[Flags]
			public enum AnimateWindowFlags:int
		{
			AW_HOR_POSITIVE = 1,
			AW_HOR_NEGATIVE = 2,
			AW_VER_POSITIVE = 4,
			AW_VER_NEGATIVE = 8,
			AW_CENTER = 16,
			AW_HIDE = 65536,
			AW_ACTIVATE = 131072,
			AW_SLIDE = 262144,
			AW_BLEND = 524288
		};
		
		/// <summary>
		///  .
		/// </summary>
		/// <param name="hwnd">.</param>
		/// <param name="dwTime">.</param>
		/// <param name="dwFlags"> .    
		///   ,    
		///    int. </param>			
		/// <returns></returns>
		[DllImportAttribute("user32.dll",EntryPoint="AnimateWindow",SetLastError=true)]
		public static extern bool AnimateWindow(IntPtr hwnd,int dwTime,int dwFlags);
		
		/// <summary>
		///  .
		/// </summary>
		/// <param name="ctrl">.</param>
		/// <param name="dwTime">.</param>
		/// <param name="Flags">.</param>		
		/// <returns></returns>
		public static bool AnimateWindow(Control ctrl,int dwTime, AnimateWindowFlags Flags)
		{
			return AnimateWindow(ctrl.Handle,dwTime,(int)Flags);
		}
		#endregion
	}
}
