using System;
using System.Text;

namespace PrecisionCounter
{

	class TestCounter
	{		
		[STAThread]
		static void Main(string[] args)
		{
			Output("           string");
			MechanismCounter.Start();
			string s = String.Empty;
			for(int i = 0; i < 10000; i++)
			{
				s+="TestPerfCounter";
			}
			float timeString = MechanismCounter.Finish();
			Output("   .   (): " + timeString);
			
			Output("           StringBuilder");
			MechanismCounter.Start();
			StringBuilder sb = new StringBuilder();
			for(int i = 0; i < 10000; i++)
			{
				sb.Append("TestCounter");
			}
			float timeStringBuilder = MechanismCounter.Finish();
			Output("   .   (): " + timeStringBuilder);
		}
		/// <summary>
		///     .
		/// </summary>
		/// <param name="s">.</param>
		static void Output(string s)
		{
			Console.WriteLine(s);
		}
	}
}
