using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using System.Text;
namespace StartTurnOff
{
		
		public class WinAPIClass
		{
			
			#region   Windows. 
			/// <summary>
			///  .
			/// </summary>
			/// <param name="shutDownType">  .</param>
			/// <param name="reason"></param>		
			/// <returns></returns>
			[DllImport("user32.dll")]
			public static extern bool ExitWindowsEx(uint shutDownType, string reason);

			//To shut down or restart the system, the calling process must use the 
			//AdjustTokenPrivileges function to enable the SE_SHUTDOWN_NAME privilege.
			//        
			//   AdjustTokenPrivileges   
			//   ()

			/// <summary>
			///   .
			/// </summary>
			public enum ShutdownType:int
			{
				LogOf = 0,
				Shutdown = 0x00000001,
				Reboot = 0x00000002,
				PowerOf = 0x00000008			
			}

			#endregion
			//  
			public const int SE_PRIVILEGE_ENABLED = 2;
			public const string SE_SHUTDOWN_NAME = "SeShutdownPrivilege";
			public const int ANYSIZE_ARRAY = 1;
			public const int TOKEN_QUERY = 8;
			public const int TOKEN_ADJUST_PRIVILEGES = 32;//0x00000020;


			
			// ,       AdjustTokenPrivileges
			//     .
			[StructLayout(LayoutKind.Sequential, Pack=1)]
			internal struct TokPriv1Luid
			{
				//    .
				public int Count;
				public long Luid;
				//  .
				public int Attr;
			}

			/// <summary>
			///     .
			/// </summary>
			/// <returns></returns>
			[DllImport("kernel32.dll", ExactSpelling=true) ]
			internal static extern IntPtr GetCurrentProcess();
			/// <summary>
			///    access token,      , 
			///     .
			/// </summary>
			/// <param name="h">  .</param>
			/// <param name="acc"> access token.</param>
			/// <param name="phtok">  access token.</param>
			/// <returns></returns>
			[DllImport("advapi32.dll", ExactSpelling=true) ]
			internal static extern bool OpenProcessToken( IntPtr h, int acc, ref IntPtr phtok );
			/// <summary>
			///       .
			/// </summary>
			/// <param name="host"> .    null,   
			///    .</param>
			/// <param name="name"> .</param>
			/// <param name="pluid">   .</param>
			/// <returns></returns>
			[DllImport("advapi32.dll") ]
			internal static extern bool LookupPrivilegeValue( string host, string name, ref long pluid );
			/// <summary>
			///    .
			/// </summary>
			/// <param name="htok">  access token</param>
			/// <param name="disall">    .</param>
			/// <param name="newst">  .      true, 
			///     .</param>
			/// <param name="len">    .</param>
			/// <param name="prev"> .</param>
			/// <param name="relen">     .</param>
			/// <returns></returns>
			[DllImport("advapi32.dll", ExactSpelling=true) ]
			internal static extern bool AdjustTokenPrivileges( IntPtr htok, bool disall,
				ref TokPriv1Luid newst, int len, IntPtr prev, IntPtr relen );

		}
	}

	

